import("./utils-364dbf4b.mjs").then((o) => {
  import(
    /* @vite-ignore */
    o.coreVersion()
  ).then((a) => {
    a.Sib.register({
      name: "solid-notifications",
      use: [
        a.ListMixin,
        a.StoreMixin
      ],
      attributes: {
        dateFormat: {
          type: String,
          default: "DD/MM/YYYY - kk:mm"
        }
      },
      initialState: {
        favicon: null,
        title: null,
        unreadCount: null,
        unreadObjects: null,
        templates: null
      },
      created() {
        import("https://cdn.skypack.dev/pin/favico.js-slevomat@v0.3.11-nyhOUAG4pt59qOhDEHAg/min/favico.js-slevomat.js").then((t) => {
          this.favicon = new t.default({ animation: "none" });
        }), this.title = "", this.templates = {}, this.unreadObjects = [], window.addEventListener("read", (t) => {
          t.detail && t.detail.resource && t.detail.resource["@id"] ? this._onReadResource(t.detail.resource["@id"]) : this._printError("Resource parameter is missing. Check the documentation: https://git.startinblox.com/framework/sib-notifications");
        }), document.addEventListener("click", (t) => {
          t.target.closest(".solid-notifications") || this._closeMenu();
        }), window.setInterval(() => {
          this.element.querySelector("details") && !this.element.querySelector("details").hasAttribute("open") && this.refresh();
        }, 3e4);
      },
      empty() {
      },
      /**
       * Overwrite ListMixin method
       * @param {Object[]} resources - List of notifications
       */
      async renderDOM(t) {
        const e = await this.getUnread(t), i = this.getTemplate(t, e.length);
        a.render(i, this.element), this._updateUnread(e);
      },
      /**
       * Returns number of unread notifications
       * @param {Object[]} notifications - List of notifications
       *
       * @returns {number}
       */
      async getUnread(t) {
        const e = [];
        for (const i of t)
          if (i && await i.unread && await i.object) {
            const s = await Promise.all([i.type, i.object, i["object.@type"]]).then(([n, r, l]) => ({ objectId: r["@id"], objectType: l, type: n })).catch(() => null);
            e.push(s);
          }
        return e;
      },
      /* TEMPLATES */
      /**
       * Returns the template of the component
       * @param {Object[]} notifications - List of notifications
       * @param {number} unreadCount - count of unread notifications
       *
       * @returns {Object} returns a litHtml TemplateResult
       */
      getTemplate(t, e) {
        return a.html`
          <div class="solid-notifications">
            <details class="solid-notifications__container">
              <summary class="solid-notifications__button">
                <img src="${o.path()}/assets/notification-icon.svg" />
                <div class="solid-notifications__counter">
                  <span data-nb-unread=${e}>${e}</span>
                </div>
              </summary>
              <div class="solid-notifications__arrow solid-notifications__triangle-back"></div>
              <div class="solid-notifications__arrow solid-notifications__triangle-shadow"></div>
              <div class="solid-notifications__list">
                ${a.until(this.getNotificationsTemplate(t))}
              </div>
            </details>
          </div>
        `;
      },
      /**
       * Filter notification and generate list template
       * @param {*} notifications
       * @returns
       */
      async getNotificationsTemplate(t) {
        const e = [];
        for (const i of t)
          await i.object && e.push(a.html`
            <div
              class="solid-notifications__item"
              @click=${() => this._onClickNotification(i.object)}
            >
              <div
                class="solid-notification"
                ?data-read=${a.until(
            i.unread.then((s) => !s),
            !1
          )}
              >
                ${a.until(this.getNotificationTemplate(i))}
                <div class="solid-notification__read">
                  <button
                    @click=${(s) => this._onClickUnread(s, i)}
                    data-unread=${a.until(
            i.unread.then((s) => s ? "unread" : "read"),
            "read"
          )}
                  ></button>
                </div>
              </div>
            </div>`);
        return e;
      },
      /**
       * Generates notification template
       * @param {Object} notification - notification
       *
       * @returns {Object} returns a litHtml TemplateResult
       */
      async getNotificationTemplate(t) {
        const i = (await t.object)["@type"];
        if (i && this.templates[i]) {
          const s = await Promise.all([
            t.summary,
            this._getFormattedDate(t.date),
            t.object,
            t.author,
            t.unread
          ]);
          let n;
          try {
            n = await a.Helpers.evalTemplateString(
              this.templates[i].innerHTML,
              {
                summary: this._sanitizeHTML(s[0]),
                date: s[1],
                object: s[2],
                author: s[3],
                unread: s[4]
              }
            );
          } catch {
            n = "<div>Notification not available</div>";
          }
          return a.html`${a.unsafeHTML(n)}`;
        }
        return a.html`
          <div class="solid-notification__avatar">
            <img src=${a.until(
          t["author.account.picture"].then((s) => s || ""),
          ""
        )} />
          </div>
          <div class="solid-notification__content">
            <solid-display
              class="solid-notification__title"
              data-src=${a.until(
          t.object.then((s) => s["@id"]).catch(() => ""),
          ""
        )}
              fields="name"
            ></solid-display>
            <p class="solid-notification__summary">${a.until(t.summary)}</p>
            <div class="solid-notification__date">
              ${a.until(this._getFormattedDate(t.date), "")}
            </div>
          </div>
        `;
      },
      /**
       * Refresh component data and re-render
       */
      async refresh() {
        this.resource && this.resource.clearCache(), a.store.getData(this.resourceId, this.context).then(this.updateDOM.bind(this));
      },
      /**
       * Saves a template used to render notifications related to specific objects
       * @param {string} type - rdf:type of the related object
       * @param {HTMLElement} template - template element to use for the notification
       */
      registerTemplate(t, e) {
        this.templates[t] = e;
      },
      /* PRIVATE */
      /**
       * Sends a request to mark a notification as read
       * @param {string} resourceId - id of the resource to patch
       * @private
       */
      async _onReadResource(t) {
        if (!this.resource)
          return;
        let e = [];
        for await (const i of this.resource["ldp:contains"])
          await i.unread && (await i["object.@id"] === t || i["@id"] === t) && e.push(a.store.patch({
            unread: !1,
            "@context": this.context
          }, i["@id"]).catch((s) => s));
        e.length && Promise.all(e).then(() => this.refresh()).catch((i) => this._printError(i));
      },
      /**
       * Handler of the click on a notification
       * @param {Object} object - object of the notification
       * @private
       */
      async _onClickNotification(t) {
        t = await t, t && (window.dispatchEvent(new CustomEvent("requestNavigation", {
          detail: { resource: t }
        })), this._closeMenu());
      },
      /**
       * Handler of the click on an unread button
       * @param {Object} e - click event
       * @param {Object} resource - related resource
       * @private
       */
      _onClickUnread(t, e) {
        t.stopPropagation(), this._closeMenu(), window.dispatchEvent(new CustomEvent("read", {
          detail: { resource: e }
        })), t.target.disabled = !0;
      },
      /**
       * Returns the date formatted as requested by the user
       * @param {Date} date - date to format
       * @private
       */
      _getFormattedDate(t) {
        return t.then((e) => e ? moment(e.toString()).format(this.dateFormat) : "");
      },
      /**
       * Update the title and favicon with the new unread count
       * @param {array} unreadNotifs - objects unread
       * @private
       */
      _updateUnread(t) {
        t === null || t.length === this.unreadCount && this.sameUnreads(this.unreadObjects, t) || (this.unreadCount = t.length, this.favicon && this.favicon.badge(this.unreadCount), this.title === "" && (this.title = document.title), t.length > 0 ? document.title = "(" + this.unreadCount + ") " + this.title : document.title = this.title, this.unreadObjects = [...t], window.dispatchEvent(new CustomEvent("notificationsCountRefresh", { bubbles: !0 })));
      },
      /**
       * Check if 2 unread arrays are identical
       * @param {*} o1
       * @param {*} o2
       */
      sameUnreads(t, e) {
        for (const [i, s] of t.entries())
          if (s.objectId !== e[i].objectId || s.objectType !== e[i].objectType || s.type !== e[i].type)
            return !1;
        return !0;
      },
      /**
       * Close notifications menu
       * @private
       */
      _closeMenu() {
        const t = this.element.querySelector("details");
        t && t.removeAttribute("open");
      },
      /**
       * Prints an error in console
       * @param {Object} error
       * @private
       */
      _printError(t) {
        console.error(t);
      },
      /**
       * Sanitize HTML to insert
       * @param {*} content
       * @returns string
       */
      _sanitizeHTML(t) {
        if (!t)
          return "";
        const e = document.createElement("div");
        return e.innerText = t, e.innerHTML;
      }
    });
  });
});
